#!/usr/bin/env python3
import pandas as pd
dfs = []
og = pd.read_csv(f"results/og10.csv").drop(['state', 'normalize', 'stem', 'duration', 'transients', 'cycle', 'td', 'prefix', 'd_pre', 'suffix', 'd', 'k', 'mc', 'gen', 'comp', 'back', 'init', 'consist', 'consec', 'inductive', 'simf', 'prop', 'reset', 'mapping', 'check', 'total', 'M', 'I', 'L', 'A', 'WM', 'WI', 'WL', 'WA'], axis=1).set_index('name')
td = pd.read_csv(f"results/td10.csv").drop(['og_mc', 'og_d', 'og_k', 'og_gen', 'og_init', 'og_consist', 'og_consec', 'og_inductive', 'og_simf', 'og_prop', 'og_reset', 'og_mapping', 'og_check', 'og_certify','og_total', 'OM', 'OI', 'OL', 'OA'], axis=1).set_index('name')
td.insert(0, 'set', '10')
dfs.append(td.join(og))
d = pd.concat(dfs)

d['oUnsat'] = d['og_k'].notna()
d['tUnsat'] = d['k'].notna()

og = pd.read_csv('results/ogbdd10.csv').set_index('name')
og['obUnsat'] = og['bdd'].notna() & (og['state'] != 'unsafe')
og = og[['bdd', 'check', 'BM', 'obUnsat']]
og.columns = ['obmc', 'obcheck', 'OBM', 'obUnsat']

td = pd.read_csv('results/tdbdd10.csv').set_index('name')
td['bUnsat'] = td['mc'].notna() & (td['state'] != 'unsafe')
td = td[['mc', 'check', 'WM', 'bUnsat']]
td.columns = ['bmc', 'bcheck', 'BddM', 'bUnsat']

d = d.join(og.join(td))
d['Unsat'] = d['oUnsat'] | d['tUnsat'] | d['obUnsat'] | d['bUnsat']
d['Sat'] = (~d['Unsat']) & (d['og_mc'].notna() | d['mc'].notna() | d['bmc'].notna() | d['obmc'].notna())

d.to_csv('data10.csv')
