#!/usr/bin/env nimcr
include "~/pCloudDrive/emacs/babel.nim"

let f = (&"ls {paramStr 1}/*.out").cmd.strip.splitLines
for i, f in f:
  let r = read f.changeFileExt "runlim"
  var f = read f
  let s = f.split("start og_certify")
  f = s[0]
  let og = (if s.len > 1: s[1] else: "")

  var state = "-"
  if   "No property" in f: state = "no_prop"
  elif "Combinatorial circuit not supported" in f: state = "no_latch"
  elif "certifaiger_td produced certificate" in f: state = "certified"
  elif "Found bad state" in f: state = "unsafe"
  elif "out of memory" in r: state = "memory"
  elif "out of time" in r: state = "time"

  var h = "name,state"
  var d = @[f.sub(" file=(.*)"), state]
  h &= ",normalize,stem,duration,transients,cycle,td"
  d &= """
  normalize
  stem_length
  duration
  len.transients.
  cycle_length
  temporal_decomposition
  """.strip.splitlines.mapit(f.sub " "&it.strip&"=(.*)")

  h &= ",prefix,d_pre,suffix,d,k,mc,bdd,gen,comp,back,init,consist,consec,inductive,simf,prop,reset,mapping,check"
  d &= """
  prefix
  d_pre
  suffix
  d
  k
  model_checking
  bdd
  k_witness_generation
  compose_witness
  backward_witness
  initiation
  consistency
  consecution
  inductive
  simf
  prop
  reset
  mapping
  check_certificate
  """.strip.splitlines.mapit(f.sub " "&it.strip&"=(.*)")

  h &= ",total"
  d &= f.sub "c (.*): (Found bad state|certifaiger_td produced certificate)"
  h &= ",M,I,L,A,WM,WI,WL,WA,BM,BI,BL,BA,OM,OI,OL,OA"
  proc parse_size(f, m: string): seq[string] =
    let s = f.sub(&"{m}_size=(.*)")
    if s == "NaN": return @["NaN", "NaN", "NaN", "NaN"]
    else: return s.split.take [0,1,2,4]
  d &= f.parse_size "model"
  var wit_size: seq[string]
  for w in ["backward_witness", "composit_witness", "forward_witness"]:
    wit_size = f.parse_size w
    if wit_size[0] != "NaN": break
  d &= wit_size
  d &= f.parse_size "og_bdd_certificate"
  d &= og.parse_size "og_certificate"

  h &= ",og_mc,og_d,og_k,og_gen,og_init,og_consist,og_consec,og_inductive,og_simf,og_prop,og_reset,og_mapping,og_check,og_certify"
  d &= """
  kind
  og_d
  og_k
  k_witness_generation
  initiation
  consistency
  consecution
  inductive
  simf
  prop
  reset
  mapping
  check_certificate
  og_certify
  """.strip.splitlines.mapit(og.sub " "&it.strip&"=(.*)")

  h &= ",og_total"
  d &= og.sub "c (.*): og_certify="

  check h.split(",").len == d.len
  if i == 0: echo h
  echo d.join(",")
