def plot(t, d):
  def cactus(c, l):
    v = d[c].dropna().sort_values()
    plt.plot(v, range(1,len(v)+1), label=f'({len(v)}) {l}', marker=".")
  cactus('td_vbs', 'TD$_{VBS}$')
  cactus('vbs', 'VBS')
  cactus('mc', 'TD$_{kind}$')
  cactus('og_mc', 'kind')
  cactus('bmc', 'TD$_{BDD}$')
  cactus('obmc', 'BDD')
  plt.xlabel("time [s]")
  plt.ylabel("Instances solved")
  plt.legend()
  t = f'plots/{t}.pdf'
  print(f'[[{t}]]')
  plt.savefig(t)
  plt.close()
import pandas as pd
import matplotlib.pyplot as plt
from tabulate import tabulate
d = pd.read_csv('data10.csv').set_index('name')
d.index = d.index.map(lambda x: x.split('/')[-1].replace('.aig', ''))
d['td_vbs'] = d[['mc', 'bmc',]].min(axis=1)
d['vbs'] = d[['og_mc', 'obmc']].min(axis=1)
plot('All', d)
plot('Unsat', d[d['Unsat']])
plot('Sat', d[d['Sat']])
