import pandas as pd
import matplotlib.pyplot as plt
from tabulate import tabulate
d = pd.read_csv('data10.csv').set_index('name')
d.index = d.index.map(lambda x: x.split('/')[-1].replace('.aig', ''))
d = d[d['Unsat']][['mc', 'check', 'bmc', 'bcheck']]
def scatter(m, c, l):
  v = d[[c, m]].dropna()
  r = (v[c].sum()/v[m].sum())
  plt.plot([r*i for i in range(10**4)], lw=2)
  plt.scatter(v[m], v[c], label=f'{l}: {r.round(2)}')

plt.axvline(7200, color='red', lw=1, zorder=1)
plt.axhline(7200, color='red', lw=1, zorder=1)
plt.plot([1*i for i in range(10000)], color='black', lw=1)
scatter('mc', 'check', 'TD$_{kind}$')
scatter('bmc', 'bcheck', 'TD$_{BDD}$')
o = d[d['bmc'].notna() & d['bcheck'].isna()].fillna(8550)
plt.scatter(o['bmc'], o['bcheck'], marker='x', color='#ff7f0e', zorder=9)

plt.xscale('log')
plt.xlim([0.002,10**4])
plt.xlabel("Model Checking [s]")
plt.yscale('log')
plt.ylim([0.002,10**4])
plt.ylabel("Certification [s]")
plt.legend()
t = 'plots/scatter.pdf'
plt.gca().set_aspect(1)

plt.savefig(t)
print(f'[[{t}]]')
