import pandas as pd
import matplotlib.pyplot as plt
from tabulate import tabulate
d = pd.read_csv('data10.csv').set_index('name')
d.index = d.index.map(lambda x: x.split('/')[-1].replace('.aig', ''))
d = d[['cycle','stem','duration','transients','k','M','mc','check','WM','bmc','bcheck','BddM']]
d.sort_values('WM', inplace=True)
# certification completed
both = d[d['check'].notna() & d['bcheck'].notna()]; bothn = 'Mean TD$_\cap$('+str(len(both))+')'
tdk = d[d['check'].notna()]; tdkn = 'Mean TD$_{\\text{kind}}$('+str(len(tdk))+')'
tdb = d[d['bcheck'].notna()]; tdbn = 'Mean TD$_{\\text{BDD}}$('+str(len(tdb))+')'
d.loc[bothn] = both.mean()
d.loc[tdkn] = tdk.mean()
d.loc[tdbn] = tdb.mean()
d = d.iloc[::-1]
precision = [['M', 'WM', 'BddM'], ['cycle', 'stem','duration', 'transients', 'k'], ['mc', 'check','bmc', 'bcheck']]
for c in precision[0]: d[c] = d[c]/1000
for p, c in enumerate(precision): d[c] = d[c].round(p)
b = d[d['check'].notna() & d['bcheck'].notna()][0:23] # certificate was at least produced
f = d[d['bcheck'].isna() & d['BddM'].notna()]
d = pd.concat([d, f])
for c in ['mc','check','WM']: d[c][tdbn] = float('nan')
for c in ['bmc','bcheck','BddM']: d[c][tdkn] = float('nan')
print(tabulate(d, tablefmt="orgtbl", showindex=True))
